/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
Routines implementing some statements and all operators
*/

#include "glb.h"
#include "sym.h"
#include "cbufs.h"
#include "logis.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
extern stck *stk0, *stk1;
extern simtck *ges;
extern hash *ctx;
extern symt *symtab;
extern long symp;
extern hash *typtab;

#include "vcmpl.c"


/* this is to eliminate code outputted to the stream */
#define SAVE_POS(y) _p=ftell(y)
#define RESTORE_POS(y) fseek(y,_p,SEEK_SET)

int c_tp = tINT, c_cl = cSCALAR;
long look_sub(char *name, int scope, int p);
etp fune_call(char *, int, int);


void analyze_print(int pt)
{
    char *t, *tp, tc;
    int my_bp = 0, sw = 0, i;
    begin_scan(stk0);
    if (pt) {
	fprintf(out, "fprintf(");
	t = scan(stk0);
	if (!tIS_INT(stk0->buf2[my_bp].tp))
	    msgrep(mERR, "Invalid file number expression type");
	if (stk0->buf2[my_bp].cl == cSCALAR)
	    fprintf(out, "getfh_s(%s),", t);
	else {
	    if (stk0->buf2[my_bp].cl == cCONST)
		fprintf(out, "_fh_%s_s,", t);
	    else
		msgrep(mERR, "Invalid file number expression class");
	}
	fprintf(out, "\"");
	my_bp++;
    } else
	fprintf(out, "printf(\"");

    while (my_bp <= stk0->buf2p) {
	t = scan(stk0);
	if (stk0->buf2[my_bp].cl == cSPEC) {
	    sw = 0;
	    my_bp++;
	    continue;
	}
	if (stk0->buf2[my_bp].cl > cSCALAR) {
	    msgrep(mERR, "can't print non-scalar types\n");
	    return;
	}
	if (sw)
	    fprintf(out, "\\t");
	if (stk0->buf2[my_bp].cl == cCONST) {
	    switch (stk0->buf2[my_bp].tp) {
	    case tINT:
	    case tBYTE:
	    case tWORD:
	    case tDWORD:
	    case tLONG:
	    case tREAL:
	    case tDBL:{
		    fprintf(out, "%s", t);
		    break;
		}
	    case tSTR:{
		    tp = t + strlen(t) - 1;
		    tc = *tp;
		    *tp = 0;
		    fprintf(out, "%s", t + 1);
		    *tp = tc;
		    break;
		}
	    default:
		fprintf(out, "%%s");
	    }
	} else {
	    switch (stk0->buf2[my_bp].tp) {
	    case tINT:
	    case tBYTE:{
		    fprintf(out, "%%hd");
		    break;
		}
	    case tLONG:{
		    fprintf(out, "%%ld");
		    break;
		}
	    case tDWORD:{
		    fprintf(out, "%%ld");
		    break;
		}
	    case tWORD:{
		    fprintf(out, "%%ud");
		    break;
		}
	    case tREAL:{
		    fprintf(out, "%%f");
		    break;
		}
	    case tDBL:{
		    fprintf(out, "%%g");
		    break;
		}
	    case tSTR:{
		    fprintf(out, "%%s");
		    break;
		}
	    default:
		fprintf(out, "%%s");
	    }
	}
	sw = 1;
	my_bp++;
    }
    if (stk0->buf2[stk0->buf2p].cl != cSPEC)
	fprintf(out, "\\n");
    fprintf(out, "\"");
    begin_scan(stk0);
    t = scan(stk0);
    my_bp = 0;
    if (pt) {
	my_bp++;
	t = scan(stk0);
    }
    while (*t) {

	if (stk0->buf2[my_bp].tp >= tMAX) {
	    i = symtab_look("str", stk0->buf2[my_bp].tp);
	    if (i > -1)
		fprintf(out, ",_%s_ff_%d_str(%s)",
			hash_by_val(typtab, stk0->buf2[my_bp].tp), i - 1,
			t);
	    else
		msgrep(mERR, "Can't print variable of this type - %s",
		       hash_by_val(typtab, stk0->buf2[my_bp].tp));
	} else {
	    if (stk0->buf2[my_bp].cl > cCONST) {
		if (stk0->buf2[my_bp].tp == tSTR)
		    fprintf(out, ",_sw(%s)", t);
		else {
		    if (stk0->buf2[my_bp].tp == tBYTE)
			fprintf(out, ",(short int)%s", t);
		    else
			fprintf(out, ",%s", t);
		}
	    }
	}
	t = scan(stk0);
	my_bp++;
    }
    fprintf(out, ");\n ");
}

void analyze_input(char *mm, int sw, int pt)
{
    char *t, *tp, tc, fn[32] = "stdin";
    int my_bp = 0, my_c = 0;
    long _p;
    SAVE_POS(out);
    if (mm != NULL) {
	fprintf(out, "printf(%s", mm);

    }
    begin_scan(stk0);
    if (pt) {
	fprintf(out, "fscanf(");
	t = scan(stk0);
	if (!tIS_INT(stk0->buf2[my_bp].tp))
	    msgrep(mERR, "Invalid file number expression type");
	if (stk0->buf2[my_bp].cl == cSCALAR)
	    fprintf(out, "getfh_s(t),");
	else {
	    if (stk0->buf2[my_bp].cl == cCONST)
		fprintf(out, "_fh_%s_s,", t);
	    else
		msgrep(mERR, "Invalid file number expression class");
	}
	fprintf(out, "\"");
	my_bp++;
	sprintf(fn, "_fh_%s_s", t);
    } else
	fprintf(out, "fscanf(stdin,\"");
    while (my_bp <= stk0->buf2p) {
	t = scan(stk0);
	if (stk0->buf2[my_bp].cl != cSCALAR)
	    msgrep(mERR, "Invalid operand class for INPUT\n");
	if (stk0->buf2[my_bp].cl == cCONST) {
	    switch (stk0->buf2[my_bp].tp) {
	    case tINT:
	    case tDBL:{
		    fprintf(out, "%s", t);
		    break;
		}
	    case tSTR:{
		    tp = t + strlen(t) - 1;
		    tc = *tp;
		    *tp = 0;
		    fprintf(out, "%s", t + 1);
		    *tp = tc;
		    break;
		}
	    }
	} else {
	    switch (stk0->buf2[my_bp].tp) {
	    case tINT:{
		    fprintf(out, "%%d");
		    break;
		}
	    case tREAL:{
		    fprintf(out, "%%g");
		    break;
		}
	    case tDBL:{
		    fprintf(out, "%%lg");
		    break;
		}
	    case tSTR:
		break;
	    }
	}
	my_bp++;
    }
    fprintf(out, "\"");
    begin_scan(stk0);
    t = scan(stk0);
    my_bp = 0;

    if (pt) {
	my_bp++;
	t = scan(stk0);
    }
    while (*t) {
	if ((stk0->buf2[my_bp].cl > cCONST)
	    && (stk0->buf2[my_bp].tp != tSTR)) {
	    fprintf(out, ",%s", t);
	    my_c++;
	}
	t = scan(stk0);
	my_bp++;
    }
    fprintf(out, ");\n ");
    if (!my_c)
	RESTORE_POS(out);

    begin_scan(stk0);
    t = scan(stk0);
    my_bp = 0;

    if (pt) {
	my_bp++;
	t = scan(stk0);
    }
    while (*t) {
	if (stk0->buf2[my_bp].tp == tSTR) {
	    fprintf(out, "_rs(%s,%s);\n", fn, t);
	}
	t = scan(stk0);
	my_bp++;
    }

}


void analyze_input2(int pt)
{
}

void analyze_linput(int pt)
{
    char *t, fn[32] = "stdin";
    int my_bp = 0;
    if (pt) {
	begin_scan(stk0);
	t = scan(stk0);
	if (!tIS_INT(stk0->buf2[my_bp].tp))
	    msgrep(mERR, "Invalid file number expression type");
	if (stk0->buf2[my_bp].cl == cSCALAR)
	    sprintf(fn, "getfh_s(%s)", t);
	else {
	    if (stk0->buf2[my_bp].cl == cCONST)
		sprintf(fn, "_fh_%s_s", t);
	    else
		msgrep(mERR, "Invalid file number expression class");
	}
    }

    begin_scan(stk0);
    t = scan(stk0);
    my_bp = 0;

    if (pt) {
	my_bp++;
	t = scan(stk0);
    }
    while (*t) {
	if (stk0->buf2[my_bp].cl != cSCALAR
	    || stk0->buf2[my_bp].tp != tSTR) msgrep(mERR,
						    "Invalid operand for LINE INPUT");
	fprintf(out, "_rl(%s,%s);\n", fn, t);
	t = scan(stk0);
	my_bp++;
    }
}


void cmpl_br()
{
    char *m;
    etp tm;
    m = strdup(popb(stk0, &tm));
    printf("for bt got %d type (%s)\n", tm.tp, m);
    sprintf(stk0->cbuf, "(%s)", m);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tm);
    free(m);
}

void ov_oper(char *nm, char o, char *l, char *r, etp tl, etp tr)
{
    long j;
    j = look_sub(nm, tl.tp, 1);
    if (j == -1) {
	msgrep(mERR, "Bad operand types for `%c'", o);
	return;
    }
    pushb(stk1, r, tr);
    pushb(stk1, l, tl);
    _mc = 1;
    fune_call(nm, 1, j);
    _mc = 0;
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
    return;
}

void ov_oper_un(char *nm, char *o, char *l, etp tl)
{
    long j;
    j = look_sub(nm, tl.tp, 1);
    if (j == -1) {
	msgrep(mERR, "Bad operand types for `%s", o);
	return;
    }
    pushb(stk1, l, tl);
    _mc = 1;
    fune_call(nm, 0, j);
    _mc = 0;
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(l);
    return;
}


void analyze_let()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    if (tr.tp == tSTR) {
	if (tr.cl == cCONST)
	    fprintf(out, "%s = mstrdup(%s);\n", l, r);
	else
	    fprintf(out, "Fss(&%s,%s);\n", l, r);
    } else
	fprintf(out, "%s = %s;\n", l, r);
    vrf_tc(tr, tl);
    free(r);
    free(l);
}

void analyze_plu()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_type(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$plu", 1, l, r, tl, tr);
	return;
    }

    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:{
		sprintf(stk0->cbuf, "%d", atoi(l) + atoi(r));
		break;
	    }
	case tLONG:
	case tDWORD:{
		sprintf(stk0->cbuf, "%ld", atol(l) + atol(r));
		break;
	    }
	case tDBL:
	case tREAL:{
		sprintf(stk0->cbuf, "%g", atof(l) + atof(r));
		break;
	    }
	case tSTR:{
		l[strlen(l) - 1] = 0;
		r++;
		sprintf(stk0->cbuf, "%s%s", l, r);
		r--;
		break;
	    }
	}
    } else {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:
	case tLONG:
	case tDWORD:
	case tREAL:
	case tDBL:{
		sprintf(stk0->cbuf, "%s+%s", l, r);
		break;
	    }
	case tSTR:{
		sprintf(stk0->cbuf, "Fas(%s,%s)", l, r);
		break;
	    }
	}
    }
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_min()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$min", 1, l, r, tl, tr);
	return;
    }

    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:
	case tLONG:
	case tDWORD:{
		sprintf(stk0->cbuf, "%d", atoi(l) - atoi(r));
		break;
	    }
	case tDBL:
	case tREAL:{
		sprintf(stk0->cbuf, "%g", atof(l) - atof(r));
		break;
	    }
	}
    } else
	sprintf(stk0->cbuf, "%s-%s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_mod()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$mod", 1, l, r, tl, tr);
	return;
    }

    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:
	case tLONG:
	case tDWORD:{
		sprintf(stk0->cbuf, "%d", atoi(l) % atoi(r));
		break;
	    }
	case tDBL:
	case tREAL:{
		sprintf(stk0->cbuf, "%d",
			((int) atof(l)) % ((int) atof(r))); break;
	    }
	}
    } else
	sprintf(stk0->cbuf, "%s%%%s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}


void analyze_eqv()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$eqv", 1, l, r, tl, tr);
	return;
    }
    switch (tl.tp) {
    case tINT:
    case tWORD:
    case tBYTE:
    case tLONG:
    case tDWORD:
    case tDBL:
    case tREAL:{
	    sprintf(stk0->cbuf, "%s==%s", l, r);
	    break;
	}
    case tSTR:{
	    sprintf(stk0->cbuf, "!mstrcmp(%s,%s)", l, r);
	    break;
	}
    }
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}


void analyze_mul()
{
    char *l, *r;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$mul", 1, l, r, tl, tr);
	return;
    }
    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:
	case tLONG:
	case tDWORD:{
		sprintf(stk0->cbuf, "%d", atoi(l) * atoi(r));
		break;
	    }
	case tDBL:
	case tREAL:{
		sprintf(stk0->cbuf, "%g", atof(l) * atof(r));
		break;
	    }
	}
    } else
	sprintf(stk0->cbuf, "%s*%s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_div()
{
    char *l, *r;
    etp tl, tr;
    int lv, rv;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper("$div", 1, l, r, tl, tr);
	return;
    }
    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:
	case tWORD:
	case tBYTE:
	case tLONG:
	case tDWORD:{
		lv = atoi(l);
		rv = atoi(r);
		if (rv == 0)
		    msgrep(mWRN, "div by zero");
		if (lv % rv) {
		    sprintf(stk0->cbuf, "%g", atof(l) / atof(r));
		    tl.tp = tDBL;
		} else
		    sprintf(stk0->cbuf, "%d", lv / rv);
		break;
	    }
	case tDBL:
	case tREAL:{
		if (atof(r) == 0)
		    msgrep(mWRN, "div by zero");
		sprintf(stk0->cbuf, "%g", atof(l) / atof(r));
		break;
	    }
	}
    } else
	sprintf(stk0->cbuf, "%s/%s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    tl.tp = tDBL;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_uminus()
{
    char *l;
    etp tl;
    l = strdup(popb(stk0, &tl));
    if (tl.cl == cCONST) {
	switch (tl.tp) {
	case tINT:{
		sprintf(stk0->cbuf, "%d", -atoi(l));
		break;
	    }
	case tDBL:{
		sprintf(stk0->cbuf, "%g", -atof(l));
		break;
	    }
	}
    } else
	sprintf(stk0->cbuf, "-%s", l);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(l);
}

void analyze_cmpr(char op)
{
    char *l, *r, *t, *on;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    switch (op) {
    case 0:
	t = "==";
	on = "$eqv";
	break;
    case 1:
	t = ">";
	on = "$grt";
	break;
    case 2:
	t = "<";
	on = "$lss";
	break;
    case 3:
	t = "!=";
	on = "$neq";
	break;
    case 4:
	t = "<=";
	on = "$leq";
	break;
    case 5:
	t = ">=";
	on = "$geq";
	break;
    }
    if (tl.tp >= tMAX) {
	printf("got %d type for %t\n", tl.tp, t);
	ov_oper(on, 1, l, r, tl, tr);
	return;
    }

    switch (tl.tp) {
    case tSTR:
	sprintf(stk0->cbuf, "mstrcmp(%s,%s)%s0", l, r, t);
	break;
    default:
	sprintf(stk0->cbuf, "%s%s%s", l, t, r);
	break;
    }
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    tl.cl = cSCALAR;
    tl.tp = tINT;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}


void analyze_or()
{
    char *l, *r, *t, *on;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper(on, 1, l, r, tl, tr);
	return;
    }
    sprintf(stk0->cbuf, "%s || %s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_and()
{
    char *l, *r, *t, *on;
    etp tl, tr;
    r = strdup(popb(stk0, &tr));
    l = strdup(popb(stk0, &tl));
    tl.cl = select_class(tl.cl, tr.cl);
    tl.tp = select_class(tl.tp, tr.tp);
    if (tl.tp >= tMAX) {
	ov_oper(on, 1, l, r, tl, tr);
	return;
    }
    sprintf(stk0->cbuf, "%s && %s", l, r);
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(r);
    free(l);
}

void analyze_neg()
{
    char *l, *on = "not";
    etp tl;
    l = strdup(popb(stk0, &tl));
    if (tl.tp >= tMAX) {
	ov_oper_un(on, "not", l, tl);
	return;
    }

    switch (tl.tp) {
    case tSTR:
	sprintf(stk0->cbuf, "!(*%s)", l);
	break;
    default:
	sprintf(stk0->cbuf, "!%s", l);
	break;
    }
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, tl);
    c_tp = tl.tp;
    c_cl = tl.cl;
    free(l);
}
