/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
Build-in functions implementation
just terrible error reporting.
*/

#include <string.h>
#include <stdlib.h>
#include "glb.h"
#include "sym.h"
#include "cbufs.h"
#include "igo.h"
#include "sym_fun.h"

extern hash *typtab;

int _bi_int(int ac);
int _bi_val(int ac);
int _bi_len(int ac);
int _bi_left(int ac);
int _bi_right(int ac);
int _bi_str(int ac);
int _bi_instr(int ac);
int _bi_mid(int ac);
int _bi_eof(int ac);
int _bi_lread(int ac);
int _bi_ltrim(int ac);
int _bi_rtrim(int ac);
int _bi_arg(int ac);
int _bi_argn(int ac);


etp bif_ov(int c, int pc, int t);


int _bif_lc = -1;
const int bifs = 24;

enum biftj { bifLEN = 0, bifVAL, bifRIGHT, bifLEFT, bifMID, bifSTR,
    bifINKEY, bifREAD, bifLREAD, bifSIN, bifCOS,
    bifATN, bifINSTR, bifEOF, bifLOF, bifTIME,
    bifDATE, bifFF, bifARG, bifARGN, bifINT, bifENV, bifERR, bifLTRIM,
    bifRTRIM
};

const 
struct bifn {
    
char name[9];
    
int code;

} biftab[] = {
    {"len", bifLEN}
    , {"val", bifVAL}
    , {"right", bifRIGHT}
    , {
"left", bifLEFT}
    , {"mid", bifMID}
    , {"str", bifSTR}
    , {"inkey", bifINKEY}
    , {"read", bifREAD}
    , {"lread", bifLREAD}
    , {"sin", bifSIN}
    , {"cos", bifCOS}
    , {"atn", bifATN}
    , {"instr", bifINSTR}
    , {"eof", bifEOF}
    , {"lof", bifLOF}
    , {"time", bifTIME}
    , {"date", bifDATE}
    , {"freefile", bifFF}
    , {"arg", bifARG}
    , {"argn", bifARGN}
    , {"int", bifINT}
    , {"env", bifENV}
    , {"err", bifERR}
    , {"ltrim", bifLTRIM}
    , {"rtrim", bifRTRIM}
};


// nm - function name
// args are on the stk1 stack 
int _bi_int(int ac);
void drop_args(int k);

int _is_built_in(char *nm)
{
    int i, c = -1;
    
for (i = 0; i <= bifs; i++)
	
if (!strcasecmp(biftab[i].name, nm)) {
	    c = i;
	    _bif_lc = c;
	    break;
	}
    if (c == -1)
	return 0;
    else
	return 1;
}

etp cmpl_built_in(int argc)
{
    etp t;
    char *a;
    if (argc) {
	a = popb(stk1, &t);
	pushb(stk1, a, t);
	if (t.tp >= tMAX)
	    return bif_ov(_bif_lc, argc, t.tp);
    }
    t.cl = cSCALAR;
    t.tp = tINT;

    switch (biftab[_bif_lc].code) {
    case bifINT:
	t.tp = _bi_int(argc);
	break;
    case bifVAL:
	t.tp = _bi_val(argc);
	break;
    case bifSTR:
	t.tp = _bi_str(argc);
	break;
    case bifRIGHT:
	t.tp = _bi_right(argc);
	break;
    case bifLEFT:
	t.tp = _bi_left(argc);
	break;
    case bifLEN:
	t.tp = _bi_len(argc);
	break;
    case bifINSTR:
	t.tp = _bi_instr(argc);
	break;
    case bifMID:
	t.tp = _bi_mid(argc);
	break;
    case bifEOF:
	t.tp = _bi_eof(argc);
	break;
    case bifENV:
	t.tp = _bi_env(argc);
	break;
    case bifERR:
	t.tp = _bi_err(argc);
	break;
    case bifDATE:
	t.tp = _bi_date(argc);
	break;
    case bifTIME:
	t.tp = _bi_time(argc);
	break;
    case bifLOF:
	t.tp = _bi_lof(argc);
	break;
    case bifREAD:
	t.tp = _bi_read(argc);
	break;
    case bifLREAD:
	t.tp = _bi_lread(argc);
	break;
    case bifLTRIM:
	t.tp = _bi_ltrim(argc);
	break;
    case bifRTRIM:
	t.tp = _bi_rtrim(argc);
	break;
    case bifARG:
	t.tp = _bi_arg(argc);
	break;
    case bifARGN:
	t.tp = _bi_argn(argc);
	break;
    }
    stk0->cbuf += strlen(stk0->cbuf) + 1;
    pushbt(stk0, t);
    return t;
}

int _bi_int(int ac)
{
    char *a;
    etp t;
    if (ac != 1) {
	fprintf(stderr, "Too many arguments for INT(...)\n");
	exit(0);
    }
    a = popb(stk1, &t);
    switch (t.tp) {
    case tDBL:
	if (t.cl == cCONST)
	    sprintf(stk0->cbuf, "%d", (int) atof(a));
	else
	    sprintf(stk0->cbuf, "((int)%s)", a);
	break;
    case tINT:
	if (t.cl == cCONST)
	    sprintf(stk0->cbuf, "%d", atoi(a));
	else
	    sprintf(stk0->cbuf, "%s", a);
	break;
    case tSTR:
	if (t.cl == cCONST) {
	    a++;
	    a[strlen(a) - 1] = 0;
	    sprintf(stk0->cbuf, "%d", atoi(a));
	} else
	    sprintf(stk0->cbuf, "atoi(%s)", a);
	break;
    }
    return tINT;
}

int _bi_val(int ac)
{
    char *a;
    etp t;
    if (ac != 1) {
	fprintf(stderr, "Too many arguments for VAL(...)\n");
	exit(0);
    }
    a = popb(stk1, &t);
    switch (t.tp) {
    case tSTR:
	if (t.cl == cCONST) {
	    a++;
	    a[strlen(a) - 1] = 0;
	    sprintf(stk0->cbuf, "%g", atof(a));
	} else
	    sprintf(stk0->cbuf, "Fs2f(%s)", a);
	break;
    }
    return tDBL;
}

int _bi_str(int ac)
{
    char *a;
    etp t;
    if (ac != 1)
	msgrep(mERR, "Too many arguments for STR(...)");

    a = popb(stk1, &t);
    switch (t.tp) {
    case tINT:
    case tWORD:
    case tDWORD:
    case tLONG:
	if (t.cl == cCONST)
	    sprintf(stk0->cbuf, "\"%s\"", a);
	else
	    sprintf(stk0->cbuf, "Fi2s(%s)", a);
	break;
    case tREAL:
    case tDBL:
	if (t.cl == cCONST)
	    sprintf(stk0->cbuf, "\"%s\"", a);
	else
	    sprintf(stk0->cbuf, "Ff2s(%s)", a);
	break;
    default:
	msgrep(mERR, "invalid argument type for STR(...)");
    }
    return tSTR;
}



int _bi_right(int ac)
{
    char *a, *b;
    etp t1, t2;
    if (ac != 2) {
	fprintf(stderr, "2 arguments for RIGHT(...)\n");
	exit(0);
    }
    a = strdup(popb(stk1, &t1));
    b = strdup(popb(stk1, &t2));
    if (t1.tp != tSTR)
	msgrep(mERR, "string expected for RIGHT(...)");
    if (!tIS_INT(t2.tp))
	msgrep(mERR, "invalid 2nd argument for RIGHT(...)");
    sprintf(stk0->cbuf, "Fright(%s,%s)", a, b);
    free(a);
    free(b);
    return tSTR;
}

int _bi_left(int ac)
{
    char *a, *b;
    etp t1, t2;
    if (ac != 2) {
	fprintf(stderr, "2 arguments for LEFT(...)\n");
	exit(0);
    }
    a = strdup(popb(stk1, &t1));
    b = strdup(popb(stk1, &t2));
    if (t1.tp != tSTR)
	msgrep(mERR, "string expected for LEFT(...)");
    if (!tIS_INT(t2.tp))
	msgrep(mERR, "invalid 2nd argument for LEFT(...)");
    sprintf(stk0->cbuf, "Fleft(%s,%s)", a, b);
    free(a);
    free(b);
    return tSTR;
}

int _bi_len(int ac)
{
    char *a;
    etp t1;
    if (ac != 1) {
	fprintf(stderr, "1 argument for LEN(...)\n");
	exit(0);
    }
    a = popb(stk1, &t1);
    if (t1.tp != tSTR)
	msgrep(mERR, "%s:string expected for LEN(...)", a);
    if (t1.cl == cCONST)
	sprintf(stk0->cbuf, "%ld", (long) strlen(a) - 2);
    sprintf(stk0->cbuf, "mstrlen(_sw(%s))", a);
    return tLONG;
}

int _bi_instr(int ac)
{
    char *a, *b, *c;
    etp t1, t2, t3;
    if (ac < 2 || ac > 3)
	msgrep(mERR, "2 or 3 arguments for INSTR(...)");
    if (ac == 2) {
	a = popb(stk1, &t1);
	if (t1.tp != tSTR)
	    msgrep(mERR,
		   "string as first argument expected for INSTR(...)");
	b = popb(stk1, &t2);
	if (t2.tp != tSTR)
	    msgrep(mERR,
		   "string as second argument expected for INSTR(...)");
	sprintf(stk0->cbuf, "Finstr(%s,%s,0)", a, b);
    } else {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR,
		   "integer numeric as first argument expected for INSTR(...)");
	b = popb(stk1, &t2);
	if (t2.tp != tSTR)
	    msgrep(mERR,
		   "string as second argument expected for INSTR(...)");
	c = popb(stk1, &t3);
	if (t3.tp != tSTR)
	    msgrep(mERR,
		   "string as third argument expected for INSTR(...)");
	sprintf(stk0->cbuf, "Finstr(%s,%s,%s)", b, c, a);
    }
    return tLONG;
}

int _bi_mid(int ac)
{
    char *a, *b, *c;
    etp t1, t2, t3;
    if (ac < 2 || ac > 3)
	msgrep(mERR, "2 or 3 arguments for MID(...)");
    if (ac == 2) {
	a = popb(stk1, &t1);
	if (t1.tp != tSTR)
	    msgrep(mERR, "string as first argument expected for MID(...)");
	b = popb(stk1, &t2);
	if (!tIS_INT(t2.tp))
	    msgrep(mERR,
		   "integer numeric as second argument expected for MID(...)");
	sprintf(stk0->cbuf, "Fmmid(%s,%s,-1)", a, b);
    } else {
	a = popb(stk1, &t1);
	if (t1.tp != tSTR)
	    msgrep(mERR, "string as first argument expected for MID(...)");
	b = popb(stk1, &t2);
	if (!tIS_INT(t2.tp))
	    msgrep(mERR,
		   "integer numeric as second argument expected for MID(...)");
	c = popb(stk1, &t3);
	if (!tIS_INT(t2.tp))
	    msgrep(mERR,
		   "integer numeric as third argument expected for MID(...)");
	sprintf(stk0->cbuf, "Fmmid(%s,%s,%s)", a, b, c);
    }
    return tSTR;
}

int _bi_eof(int ac)
{
    char *a;
    etp t1;
    if (ac > 1)
	msgrep(mERR, "0 or 1 argument for LOF(...)");
    if (ac == 0) {
	sprintf(stk0->cbuf, "feof(stdin)");
	return tINT;
    }
    a = popb(stk1, &t1);
    if (!tIS_INT(t1.tp))
	msgrep(mERR, "integer numeric expected for LEN(...)");
    if (t1.cl == cCONST) {
	check_file_num(atoi(a));
	sprintf(stk0->cbuf, "feof(_fh_%s_s)", a);
    } else {
	sprintf(stk0->cbuf, "feof(getfh_s(%s))", a);
    }
    return tINT;
}

int _bi_env(int ac)
{
    char *a;
    etp t1;
    if (ac != 1) {
	msgrep(mERR, "1 argument for ENV(...)");
	exit(0);
    }
    a = popb(stk1, &t1);
    if (t1.tp != tSTR)
	msgrep(mERR, "string expected for ENV(...)");
    sprintf(stk0->cbuf, "mstrdup(getenv(%s))", a);
    return tSTR;
}

int _bi_err(int ac)
{
    char *a;
    etp t1;
    if (ac > 1) {
	msgrep(mERR, "zero or one argument for ERR(...)");
	exit(0);
    }
    if (ac) {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for ERR(...)");
	sprintf(stk0->cbuf, "(_errf==%s)", a);
    } else {
	sprintf(stk0->cbuf, "_errf");
    }
    return tINT;
}

int _bi_date(int ac)
{
    if (ac > 0)
	msgrep(mERR, "zero arguments for DATE(...)");
    sprintf(stk0->cbuf, "Fdate()");
    return tSTR;
}

int _bi_time(int ac)
{
    if (ac > 0)
	msgrep(mERR, "zero arguments for TIME(...)");
    sprintf(stk0->cbuf, "Ftime()");
    return tSTR;
}

int _bi_argn(int ac)
{
    if (ac > 0)
	msgrep(mERR, "zero arguments for ARGN(...)");
    sprintf(stk0->cbuf, "_argn");
    return tINT;
}

int _bi_arg(int ac)
{
    char *a;
    etp t1;
    if (ac != 1)
	msgrep(mERR, "1 argument for ARG(...)");
    a = popb(stk1, &t1);
    if (!tIS_INT(t1.tp))
	msgrep(mERR, "integer numeric expected for AGR(...)");
    sprintf(stk0->cbuf, "argv[(int) %s]", a);
    return tSTR;
}

int _bi_lof(int ac)
{
    char *a;
    etp t1;
    if (ac != 1) {
	msgrep(mERR, "1 argument for ENV(...)");
	exit(0);
    }
    a = popb(stk1, &t1);
    if (!tIS_INT(t1.tp))
	msgrep(mERR, "integer numeric expected for LOF(...)");
    check_file_num(atoi(a));
    sprintf(stk0->cbuf, "Flof(_fh_%s_s)", a);
    return tINT;
}

int _bi_read(int ac)
{
    char *a, *b;
    etp t1, t2;
    if (ac < 1 || ac > 2)
	msgrep(mERR, "1 or 2 arguments for READ(...)");
    if (ac == 1) {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	sprintf(stk0->cbuf, "Fread(%s,stdin)", a);
    } else {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	b = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	check_file_num(atoi(b));
	sprintf(stk0->cbuf, "Fread(%s,_fh_%s_s)", a, b);
    }
    return tSTR;
}

int _bi_lread(int ac)
{
    char *a, *b;
    etp t1, t2;
    if (ac < 1 || ac > 2)
	msgrep(mERR, "1 or 2 arguments for READ(...)");
    if (ac == 1) {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	check_file_num(atoi(a));
	sprintf(stk0->cbuf, "Flread(_fh_%s_s,1024)", a);
    } else {
	a = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	check_file_num(atoi(a));
	b = popb(stk1, &t1);
	if (!tIS_INT(t1.tp))
	    msgrep(mERR, "integer numeric expected for READ(...)");
	sprintf(stk0->cbuf, "Flread(_fh_%s_s,%s)", a, b);
    }
    return tSTR;
}


int _bi_ltrim(int ac)
{
    char *a;
    etp t1;
    if (ac != 1)
	msgrep(mERR, "1 argument for LTRIM(...)");
    a = popb(stk1, &t1);
    if (t1.tp != tSTR)
	msgrep(mERR, "string expected for LTRIM(...)");
    sprintf(stk0->cbuf, "Fltrim(%s)", a);
    return tSTR;
}

int _bi_rtrim(int ac)
{
    char *a;
    etp t1;
    if (ac != 1)
	msgrep(mERR, "1 argument for RTRIM(...)");
    a = popb(stk1, &t1);
    if (t1.tp != tSTR)
	msgrep(mERR, "string expected for RTRIM(...)");
    sprintf(stk0->cbuf, "Frtrim(%s)", a);
    return tSTR;
}




etp bif_ov(int c, int pc, int t)
{
    int i;
    etp tt;
    i = symtab_look(biftab[c].name, t);
    _mc++;
    if (i > -1)
	tt = fune_call(biftab[c].name, pc - 1, i - 1);
    _mc--;
    return tt;
}


void drop_args(int k)
{
    int i;
    etp t;
    if (k > 1) {
	if (k > 2)
	    for (i = 0; i < k - 2; i++)
		sprintf(stk0->cbuf, "%s%s,", stk0->cbuf, popb(stk1, &t));
	sprintf(stk0->cbuf, "%s%s", stk0->cbuf, popb(stk1, &t));
    }
}
