/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
programme start up and finish.
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include "sym.h"
#include "cbufs.h"
extern void yyparse(void);
extern long flof(FILE * fp);

void fin();

extern FILE *yyin, *out, *dec;
extern stck *stk0, *stk1;
extern simtck *ges, *far;
extern hash *ctx;
hash *fileh, *sfileh, *tfileh;
int req_adr;
int indv = 0;
long lineno = 0;
FILE *mprg, *tmp1, *tmp2, *tmp, *sub;
char *nout, *ndec, *ntmp, *ntmp1, *ntmp2, *nsub, *linfo_name = "xxx.bas";
void put2f(FILE * dst, char *name);

void SIGINT_hld(int signum)
{
    printf("---interrupted\n");
    fin();
}

void SIGSEGV_hld(int signum)
{
    printf("Memory violation catched!\n");
    exit(0);
}

void up_and_go()
{
    struct sigaction ma1;
    struct sigaction ma2;
    memset(&ma1, 0, sizeof(ma1));
    ma1.sa_handler = SIGINT_hld;
    memset(&ma2, 0, sizeof(ma2));
    ma2.sa_handler = SIGSEGV_hld;
    if (sigaction(SIGINT, &ma1, NULL) || sigaction(SIGSEGV, &ma2, NULL)) {
	printf("Fault setting signals\n");
	exit(0);
    }

    lineno = 1;
    stk0 = new_buf_stack(16384, 1024, "<cmpl-first>");
    stk1 = new_buf_stack(8129, 512, "<cmpl-second>");
    ges = new_buf_sim_stack(512, "<ges>");
    far = new_buf_sim_stack(255, "<fun-arg>");
    ctx = new_buf_hash(128, "<ctx>");
    fileh = new_buf_hash(128, "<valid files 1>");
    sfileh = new_buf_hash(128, "<valid files 2>");

    create_symtab();
    mprg = fopen("fccout.c", "w+");

    nout = tempnam(NULL, "fc");
    out = fopen(nout, "w+");

    nsub = "fccsub.c";
    sub = fopen(nsub, "w+");

    ndec = tempnam(NULL, "fcdec");
    dec = fopen(ndec, "w+");

    ntmp = tempnam(NULL, "fct");
    tmp = fopen(ntmp, "w+");

    ntmp1 = tempnam(NULL, "fct1");
    tmp1 = fopen(ntmp1, "w+");

    ntmp2 = tempnam(NULL, "fct2");
    tmp2 = fopen(ntmp2, "w+");

    do {
	yyparse();
    } while (!feof(yyin));
    fin();
}

void fin()
{
    fclose(out);
    fclose(dec);
    fclose(tmp);
    fclose(tmp1);
    fclose(tmp2);
    fclose(sub);
    fprintf(mprg,
	    "#include <stdio.h>\n#include <stdlib.h>\n#include <string.h>\n#include \"afcs_gen.c\"\n");
    put2f(mprg, ntmp);
    fprintf(mprg, "int _argn;\nchar** _argv;\n");
    fprintf(mprg,
	    "int _errf;\n#include \"%s\"\nint main(int argn,char* argv[])\n{\n",
	    nsub);
    put2f(mprg, ndec);
    fprintf(mprg, "_argn=argn;\n_argv=argv;\n");
    put2f(mprg, nout);
    fprintf(mprg, "_go_gc();\n_2go_gc();\n");
    fprintf(mprg, "return 0;}\n");
    fclose(mprg);
    unlink(nout);
    unlink(ndec);
    unlink(ntmp);
    unlink(ntmp1);
    unlink(ntmp2);
    free(nout);
    free(ndec);
    free(ntmp);
    free(ntmp1);
    free(ntmp2);
    symtab_show("s.out");
    free_symtab();
    free_buf(stk1);
    free_buf(stk0);
    free_sbuf(ges);
    free_sbuf(far);
    exit(0);
}


void put2f(FILE * dst, char *name)
{
    FILE *src;
    char *tok;
    long tf;
    src = fopen(name, "r");
    tf = flof(src);
    tok = (char *) malloc(tf + 1);
    fread((void *) tok, 1, tf, src);
    *(tok + tf) = '\0';
    fflush(dst);
    fprintf(dst, "%s\n", tok);
    fflush(dst);
    fclose(src);
    free(tok);
}

void f2f(FILE * dst, FILE * src)
{
    char *tok;
    long tf, tp;
    tf = flof(src);
    tok = (char *) malloc(tf + 1);

    tp = ftell(src);
    fseek(src, 0, SEEK_SET);

    fread((void *) tok, 1, tf, src);
    *(tok + tf) = '\0';
    fflush(dst);

    fprintf(dst, "%s\n", tok);
    fseek(src, tp, SEEK_SET);
    fflush(dst);
    free(tok);
}

FILE *reset(char *n, FILE * f)
{
    fclose(f);
    return fopen(n, "w+");
}
