%{
/*This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.*/

#include "sym.h"
#include "y.tab.h"
#include "glb.h"
#include <math.h>
extern char* strdup(char*);
extern char* reformat(char* s);
%}

%x DIE

%%

"INCLUDE"  {return INCLUDE;}
FOR       {return FOR;}
TO        {return TO;}
STEP      {return STEP;}
NEXT      {return NEXT;}
LET       {return LET;}
IF        {return IF;}
ME        {return ME;}
THEN      {return THEN;}
ELSE      {return ELSE;}
WHILE     {return WHILE;}
WEND      {return WEND;}
DO([\n\t ]*)WHILE  {return DO_WHILE;}
DO        {return DO;}
LOOP      {return LOOP;}
LOOP([\n\t ]*)WHILE  {return LOOP_WHILE;}
LOOP([\n\t ]*)UNTIL  {return LOOP_UNTIL;}
UNTIL     {return UNTIL;}
PRINT|[?] {return PRINT;}
DIM       {return DIM;}
AS        {return AS;}
TYPE      {return TYPE;}
SUB       {return SUB;}
END([\n\t ]*)TYPE {return END_TYPE;}
END([\n\t ]*)SUB  {return END_SUB;}
FUNC|FUNCTION  {return FUNCTION;}
DECL|DECLARE   {return DECLARE;}
OPT|OPTIONAL  {return OPTIONAL;}
OPERATOR  {return OPERATOR;}
BYREF     {return BYREF;}
BYVAL     {return BYVAL;} 
SHARED    {return SHARED;} 
STATIC    {return STATIC;} 
DYNAMIC   {return DYNAMIC;} 
CALL      {return CALL;} 
SELECT    {return SELECT;}
CASE      {return CASE;} 
IS        {return IS;} 
IN        {return IN;} 
END([\n\t ]*)SELECT {return END_SELECT;}
CASE([\n\t ]*)ELSE {return CASE_ELSE;}
END       {return END;}
STRING    {return STRING;}
INPUT     {return INPUT;}
LINE      {return LINE;}
OPEN      {return OPEN;}
CLOSE     {return CLOSE;}
OUTPUT    {return OUTPUT;}
APPEND    {return APPEND;}
RANDOM    {return RANDOM;}
ERROR     {return _ERROR;}
ON        {return _ON;}
CLASS     {return CLASS;}
PUBLIC    {return PUBLIC;}
EXTENDS   {return EXTENDS;}
FRIENDS   {return FRIENDS;}
EXTERN    {return EXTERN;}
FROM      {return FROM;}
PIPE      {return PIPE;}
AND       {return AND;}
OR        {return OR;}
NOT       {return NOT;}
EXIT      {return EXIT;}
CONTINUE  {return CONTINUE;}
  
(<>)|(!=) {return NQ;}
(>=)|(=>) {return GQ;}
(<=)|(=<) {return LQ;}


<INITIAL><<EOF>> {BEGIN DIE;return NL_DELIM;}

<DIE><<EOF>> return 0;

[:]+ {return CL_DELIM;}
[\n\r]+ {lineno++;return NL_DELIM;}
(\"[^\"\n]*\") {yylval.sval=strdup(yytext);return DQSTRING;}
(`[^`\n]*`) {yylval.sval=reformat(yytext);return DQSTRING;}
"'"(.*)[\n] {lineno++;return NL_DELIM;};
"'"(.*)[^\n] ; 

([0-9]+) {return INUMBER;}
([0-9]+|([0-9]*\.[0-9]+)([eE][-+]?[0-9]+)?) {return FNUMBER;}
  

[ \t] ;
[a-z][_a-z0-9]* {yylval.sval=strdup(yytext);return NAME;}


.  return yytext[0];
%%
