/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
Lemick Basic grammar.
It has 6 shift/reduce conflicts (on GNU bison).
*/

%{ 
 #include <stdio.h>
 #include "glb.h"
 #include "sym.h"
 #include "sym_fun.h"
 #include "sym_arr.h"
 #include "cbufs.h"
 #include "cmpl.h"
 #include "igo.h"
 #include "scase.h"
 #define DEFTYPE tINT
 const char* auth="\n  Ith Basic 0.1.0 Copyright (C) 2001 Alex Iliasov.\n\n\tLemick Basic may be copied under the terms of GNU General Public License.\n\n\n";
 etp _t;
 char* _te,*ts;  
 extern FILE* lfh,*yyin;
 extern int _oac;
 int escope=0; //switches between sub/main/module/etc code
 int _cc;
 int _nc,_pub=1;
 int _mc=0;
 int _e_flags=0;
 long osymf;
 extern stck *stk0,*stk1;
 #define FCD symf|=sf_INSIDE_TYPE
 #define ACD symf&=~sf_INSIDE_TYPE
%}

%union {
   int ival;
   char* sval;
   };

%nonassoc HGH
%token CL_DELIM NL_DELIM YEOF END_SUB END_TYPE 
%token IF THEN ELSE ENDIF THENB INPUT LINE _ERROR _ON
%token NQ LQ GQ OPEN CLOSE OUTPUT INPUT APPEND RANDOM
%token SELECT CASE IS CASE_ELSE STRING IN LET END_SELECT
%token DO WHILE LOOP WEND UNTIL DO_WHILE LOOP_WHILE LOOP_UNTIL
%token FOR TO STEP NEXT CALL SHARED STATIC DYNAMIC
%token <sval> DQSTRING SQSTRING DQCHAR SQCHAR
%token SUB FUNCTION DECLARE OPTIONAL BYREF BYVAL
%token CLASS PUBLIC EXTENDS FRIENDS OPERATOR ME
%token EXTERN FROM PIPE AND OR NOT EXIT
%token FNUMBER INUMBER CONTINUE ESCS INCLUDE
%token FOR TO STEP PRINT AS DIM TYPE END
%token <sval> NAME
%nonassoc '('
%left AND OR
%right '='
%left '<' '>' NQ LQ GQ
%left '-' '+'
%left '%'
%left '*' '/'
%nonassoc UMINUS NOT
%nonassoc LOW
%type <ival> bin_ops
%type <ival> comma_or_scolon
%type <ival> mode 
%type <sval> oper 
%type <ival> dtype 
%type <ival> inum 
%type <ival> dtype_name 
%type <ival> maybe_fh
%type <ival> maybe_pipe
%%
	  
statement_list: m_statement ST_DELIM
              | statement_list m_statement ST_DELIM
              | statement_list error m_statement ST_DELIM
	      ;

m_statement: INUMBER statement {flush_buf(stk0);flush_buf(stk1);}
           | statement {flush_buf(stk0);flush_buf(stk1);}
	   ; 

statement_cl: statement {flush_buf(stk0);flush_buf(stk1);}
            | statement_cl CL_DELIM statement {flush_buf(stk0);flush_buf(stk1);fprintf(out,"_go_gc();\n");}
	    ; 

statement: 
         | INCLUDE DQSTRING {fprintf(tmp,"#include %s\n",$2);free($2);}
         | DIM dim_dec_list
         | DIM SHARED {
	         push(ges,cscope);
	         cscope=1;lfh=dec;dec=tmp;} 
	         dim_dec_list {cscope=pop(ges);dec=lfh;}
         | DIM STATIC {fprintf(dec,"static ");} dim_dec_list 
         | CLASS NAME {sym_enter_type($2);free($2);escope=last_type;symf|=sf_NODEC;_pub=0;} maybe_ST_DELIM maybe_extends maybe_ST_DELIM
             maybe_private_declarations
             maybe_public_declarations 
	   END CLASS {sym_leave_type();escope=0;symf&=~sf_NODEC;_pub=1;}
         | TYPE NAME {sym_enter_type($2);free($2);escope=last_type;} 
 	     ml_strict_dec_list 
             maybe_constructor
	   END_TYPE {sym_leave_type();escope=0;}
         | _ON event_name statement
/*         | maybe_let {symf|=sf_INSIDE_LET;printf("Set INSIDE_LET\n");} ottimo_name '=' expression {analyze_let();}
*/      
         | ottimo_name_ext '=' expression {analyze_let();}
         | OPEN maybe_pipe expression AS mb_fh_sm expression {fio_open(1,$2);}
         | OPEN maybe_pipe expression FOR mode AS mb_fh_sm expression {fio_open($5,$2);}
         | CLOSE mb_fh_sm close_num_list
         | PRINT maybe_fh lep_expression { analyze_print($2); }
         | INPUT maybe_fh {req_adr=1;} l_names { analyze_input(NULL,0,$2);req_adr=0; }
         | INPUT DQSTRING comma_or_scolon {req_adr=1;} l_names { analyze_input($2,$3,0);req_adr=0; }
         | LINE INPUT maybe_fh {req_adr=1;} l_names { analyze_linput($3);req_adr=0; }
         | IF expression aTHEN 
	         statement_cl {a_if_end();}
         | IF expression aTHEN 
	         statement_cl aELSE statement_cl {a_if_end();}
	 | IF expression aTHEN NL_DELIM
	      statement_list 
	     END IF {a_if_end();}
	 | IF expression aTHEN NL_DELIM
	      statement_list 
              aELSE
	      statement_list 
	     END IF {a_if_end();}
         | FOR ottimo_name '=' expression TO expression mbstep {analyze_for1();}
	     statement_list
	   NEXT mbids {analyze_for2();}    
         | WHILE expression {analyze_while1();} statement_list WEND {analyze_wend();}
         | DO_WHILE expression {analyze_while1();} statement_list LOOP {analyze_wend();}
         | DO statement_list LOOP_WHILE expression 
         | DO statement_list LOOP_UNTIL expression 
         | select_case
         | SUB function_header { enter_fun_dec(_nc,fdf_WRITE);escope=-1; } 
	    statement_list
	   END_SUB             { leave_fun_dec();escope=0; }
         | FUNCTION function_header AS rv_type { enter_fun_dec(_nc,fdf_WRITE | fdf_FUNCTION);escope=-1; }
	    statement_list
	   END FUNCTION        { leave_fun_dec();escope=0; }
         | DECLARE FUNCTION function_header AS rv_type maybe_exter_des { enter_fun_dec(_nc,fdf_WRITE | fdf_FUNCTION | fdf_DECLARE | _e_flags);}
         | DECLARE SUB function_header maybe_exter_des {enter_fun_dec(_nc,fdf_WRITE | fdf_DECLARE | _e_flags );}
         | ottimo_name { call_write(); }
         | EXIT SUB {exit_sub();}
         | EXIT FUNCTION {exit_sub();}
         | EXIT WHILE {exit_while();}
         | EXIT FOR {exit_for();}
         | CONTINUE {cont();}
         | END {my_end();}
	 ; 
/*
  dim u(10)
  u(10)=2  - assign array 2
  u (10)=2 - call function u with single arg 10=2
*/

maybe_pipe: {$$=0;} | PIPE {$$=1;};

close_num_list: {fio_close_all();}
              | list_cnum
	      ;

list_cnum: inum {fio_close($1);}
         | list_cnum ',' inum {fio_close($3);}
	      
maybe_extends: | EXTENDS ext_name_list ;

maybe_private_declarations: | private_declarations ST_DELIM;
maybe_public_declarations: | PUBLIC {_pub=1;} maybe_ST_DELIM private_declarations ST_DELIM;


private_declarations: private_declaration 
                    | private_declarations ST_DELIM private_declaration
		    ;

private_declaration: SUB function_header { enter_fun_dec(_nc,fdf_WRITE|fdf_CD);escope=last_type;} 
			statement_list
	              END_SUB  { leave_fun_dec(); }           
                   | FUNCTION function_header AS rv_type { enter_fun_dec(_nc,fdf_WRITE|fdf_CD| fdf_FUNCTION);escope=last_type;} 
			statement_list
	             END FUNCTION { leave_fun_dec(); }       
                   | DIM {symf&=~sf_NODEC;} dim_dec_list {symf|=sf_NODEC;}
		   ;
		           
maybe_let: | LET ; 

maybe_constructor: | ST_DELIM SUB function_header { enter_fun_dec(_nc,fdf_WRITE|fdf_CD); } 
	              statement_list END_SUB ST_DELIM { leave_fun_dec(); } ;


maybe_exter_des: {_e_flags=0;} | exter_des;
exter_des: EXTERN maybe_more {_e_flags|=fdf_EXTERN;}
         | FROM DQSTRING maybe_as
         ;

maybe_more: | lang_id maybe_func_name ;
maybe_func_name: | DQSTRING;
maybe_as: AS DQSTRING;
lang_id: NAME ;

mbstep:
      | STEP expression {pushb(stk0,"x",metp(1,cSPEC));}
      ; 

mbids:
     | ids_list
     ;

mode: OUTPUT {$$=1;} | INPUT {$$=2;} | APPEND {$$=3;} | RANDOM {$$=4;} ;

aTHEN: THEN {a_if_then();} ;
aELSE: ELSE {a_if_else();} ;

ids_list: ottimo_name
        | ids_list ',' ottimo_name
        ;
/*
name_list: NAME
         | name_list ',' NAME
         ;
*/

ext_name_list: NAME {sym_add_ext($1); free($1);}
             | ext_name_list ',' NAME {sym_add_ext($3); free($3);}
             ;

      
mbnl_expression:
               | l_expression
               ;


l_expression: expression {_cc=1;}
            | l_expression ',' expression {_cc++;}
            ;

le_expression: {symf|=sf_EMPTY_ELIST;}
             | l_expression 
             ;

lep_expression: le_expression
              | lep_expression ';' {pushb(stk0,";",s_SYMB);} le_expression
              ;

l_names: ottimo_name
       | l_names ',' ottimo_name
       ;

       
expression: expression '+' expression { analyze_plu();}
          | expression '-' expression { analyze_min();}
          | expression '*' expression { analyze_mul();}
          | expression '/' expression { analyze_div();}
          | expression '%' expression { analyze_mod();}
          | expression '=' expression { analyze_cmpr(0);}
          | expression '>' expression { analyze_cmpr(1);}
          | expression '<' expression { analyze_cmpr(2);}
          | expression NQ expression { analyze_cmpr(3);}
          | expression LQ expression { analyze_cmpr(4);}
          | expression GQ expression { analyze_cmpr(5);}
          | expression AND expression { analyze_and();}
          | expression OR expression { analyze_or();}
	  | '(' expression ')' {cmpl_br();} ;
          | '-' expression %prec UMINUS { analyze_uminus();}
          | '+' expression %prec UMINUS {}  /* do-nothing is the best here */
          | NOT expression %prec UMINUS { analyze_neg();}  /* do-nothing is the best here */
          | ME {analyze_me();}
          | FNUMBER  {pushb(stk0,yytext,CT_DBL);c_tp=tDBL;c_cl=cSCALAR;}
          | INUMBER  {pushb(stk0,yytext,CT_INT);c_tp=tINT;c_cl=cSCALAR;}
          | DQSTRING {pushb(stk0,$1,CT_STR);c_tp=tSTR;c_cl=cSCALAR;}
	  | ottimo_name {}
	  ;

 /*
  a.b.c.. -> variable or method
  f(x), y.f(x), a.b. ... .c.f(x)   -> array or variable or function or method
  f(x).y -> variable or method
  f.y -> variable or method
  
 */

part_name: dec_name_nm {pushbt(stk0,symtab_get_sym(stk0->elast));} 
         | dec_name_nm {pushbt(stk0,s_NAME_AR);} '(' 
	          {
                   push(far,symf);
                   push(far,_mc);
    	           //printf("(2.1) SYMF:%ld\n",symf);
		   symf&=~(sf_NO_AUTO_DEC | sf_COMPLX_NAME);
    	           //printf("(2.2) SYMF:%ld\n",symf);
		   push(ges,cscope);
		   cscope=escope;
/*		   printf("Cscope=%d\n",cscope);*/
		  }
		  le_expression ')' 
		  {
		   _mc=pop(far);
		   symf=pop(far);
    	           //printf("(3) SYMF:%ld\n",symf);
		   cscope=pop(ges);
		   sym_get_sym_arr();
/*		   symf|=sf_NO_AUTO_DEC | sf_COMPLX_NAME; */
		  }
		   
         ; 

full_name: part_name {
//		      printf("Entry scope %d\n",cscope);
                      push(ges,cscope);
                      cscope=stk0->buf2[stk0->buf2p].tp;
//                      printf("New scope %d\n",cscope);
		      symf|=sf_NO_AUTO_DEC | sf_COMPLX_NAME;
		      //printf("(1) SYMF:%ld\n",symf);
		      _mc=_mc+1;
		      }
         | full_name '.' part_name {tumble();}
         ;

function_header: NAME {pushb(stk1,$1,s_NAME_SC);_nc=0;namef=0;_oac=0;flush_sbuf(far);} '(' fun_dec_list1 ')' 
               | OPERATOR oper {pushb(stk1,$2,s_NAME_SC);_nc=0;namef=0;_oac=0;flush_sbuf(far);} '(' fun_dec_list1 ')'       
               ;

fun_dec_list1: 
             | fun_dec_list
	     ;

fun_dec_list: fun_dec_name {push(far,namef);_nc++;}
            | fun_dec_list ',' {namef=0;}  fun_dec_name {push(far,namef);_nc++;}
	    ;

fun_dec_name: fun_dec_nom0 | fun_dec_nom1 
            | OPTIONAL fun_dec_nom0 '=' expression {_oac++;namef|=nf_OPTIONAL;}
            ;

fun_dec_nom0: qual NAME {pushb(stk1,$2,metp(DEFTYPE,cSCALAR));free($2);}
            | qual NAME AS dtype {pushb(stk1,$2,metp($4,cSCALAR));free($2);namef|=nf_EXTYPE;}
	    ;

fun_dec_nom1: qual NAME '(' comma_values ')' {pushb(stk1,$2,metp(alloc_arr_type(DEFTYPE,_cc+1,0,0),cARRAY));free($2); namef|=nf_ARTYPE;}
            | qual NAME '(' comma_values ')' AS dtype {pushb(stk1, $2, metp(alloc_arr_type($7,_cc+1,0,0),cARRAY));printf("**R1**\n");free($2);namef|=nf_EXTYPE | nf_ARTYPE;}
            | DYNAMIC NAME '(' commas ')' AS dtype {pushb(stk1, $2, metp(alloc_arr_type($7,_cc+1,1,0),cARRAY));free($2);namef|=nf_EXTYPE | nf_ARTYPE;}
            | DYNAMIC NAME '(' commas ')' {pushb(stk1, $2, metp(alloc_arr_type(DEFTYPE,_cc+1,1,0),cARRAY));free($2);namef|=nf_EXTYPE | nf_ARTYPE;}
            ;

qual: | qual1 ;
quala: | DYNAMIC ;

qual1: BYVAL {namef|=nf_BYVAL;}
     | BYREF {namef|=nf_BYREF;}
     ;

commas: {_cc=0;}
      | rcommas
      ;    

rcommas: ',' {_cc=1;}
       | rcommas ',' {_cc++;}
       ;    

comma_values: {_cc=0;} | ',' le_expression ;


dim_dec_list: tp_dec_name
            | dim_dec_list ',' tp_dec_name
	    ;

tp_dec_name: dec_name {symtab_add_sym_chk(popbe(stk0),DEFTYPE,cscope);}
           | dec_name AS mc_dtype 
           | dec_name AS dtype '=' hold_expression {symtab_add_sym_chk(popbe(stk0),$3,cscope);}
           | dec_name '=' hold_expression {symtab_add_sym_chk(popbe(stk0),DEFTYPE,cscope);}
           ;
hold_expression: expression {symf|=sf_EXPL_INIVAL;} ;

strict_dec_list: 
               | dec_name AS dtype {symtab_add_sym_chk(popbe(stk0),$3,cscope);} 
               ;

ml_strict_dec_list: strict_dec_list
                  | ml_strict_dec_list ST_DELIM strict_dec_list
                  | ml_strict_dec_list error ST_DELIM strict_dec_list
                  ;

dec_name: dec_name_nm {pushbt(stk0,s_NAME_SC);}
        | dec_name_nm {pushbt(stk0,s_NAME_AR);} '(' l_expression ')'
        ; 

ottimo_name_ext: ottimo_name 
               | OPERATOR oper {pushbe(stk0,$2);
	                        pushbt(stk0,symtab_get_sym(stk0->elast));}
	       ;

ottimo_name: full_name {symf&=~(sf_NO_AUTO_DEC | sf_COMPLX_NAME) ;cscope=pop(ges); addhr(ctx,"",ctx_PART_NAME);_mc=0;} ;
/*           | dec_name AS dtype {pushbt(stk0,symtab_add_sym_chk_ret(popbe(stk0),$1,cscope));}
*/           ;
	   
dec_name_nm: NAME {pushbe(stk0,$1);free($1);}
           ;     

/* type declaration with constructor */
mc_dtype: dtype {symtab_add_sym_chk(popbe(stk0),$1,cscope);}
        | dtype_name '(' {
	     _nc=0;FCD;
	     symtab_add_sym_chk(popbe(stk0),$1,cscope);
	     ACD;
	     } mc_le_exp ')' {use_constr();};
	;

           /* very unsafe code! - depends on the order of arg. evaluation*/
mc_l_exp: expression {_nc=1;ts=popb(stk0,&_t);pushb(stk1,ts,_t);}
        | mc_l_exp ',' expression  {_nc++;pushb(stk1,popb(stk0,&_t),_t);}
        ;

mc_le_exp: {symf|=sf_EMPTY_ELIST;}
         | mc_l_exp 
         ;


dtype_name: NAME {$$=sym_get_type($1);free($1);} ;

dtype: NAME {$$=sym_get_type($1);free($1);}
     | STRING {$$=tSTR;}
     | STRING '*' INUMBER {$$=tSTR;}
     ; 

rv_type: dtype {pushb(stk0,"*",metp($1,cSCALAR));} 
       | dtype {_cc=0;} '(' commas ')' {pushb(stk1,"*",metp(alloc_arr_type($1,_cc,0,0),cARRAY));}
       ;

comma_or_scolon: ',' {$$=1;} | ';' {$$=2;} ;

mb_fh_sm: | '#' | '@' ;
maybe_fh: {$$=0;}
        | '#' expression ',' {$$=1;}     //expression is to be of type file
        | '@' expression ',' {$$=2;}    
        ;

select_case: SELECT CASE expression {scase_start();}
             NL_DELIM s_cases 
             maybe_case_else
	     END_SELECT; {scase_end();}

cases: CASE '=' expression {scase_case_plain();}
            ST_DELIM statement_list {scase_case_end();}
     | CASE {scase_case_range();} ranges {scase_case_range_end();}    
            ST_DELIM statement_list {scase_case_end();}
     | CASE IS bin_ops expression {scase_case_binops($3);}
            ST_DELIM statement_list {scase_case_end();}
     ;

maybe_case_else: | CASE_ELSE statement_list ;

oper: '+' {$$="$plu";} | '-' {$$="$min";} | '*' {$$="$mul";} | '/' {$$="$div";} | '%' {$$="$mod";}
    | '=' {$$="$eqv";} | '>' {$$="$grt";} | '<' {$$="$lss";} | NQ {$$="$neq";} | LQ {$$="$leq";} | GQ {$$="$geq";} ;

bin_ops: '=' {$$=0;} | '>' {$$=1;} | '<' {$$=2;} | NQ {$$=3;} | LQ {$$=4;} | GQ {$$=5;} ;

s_cases: cases
       | s_cases cases
       ;


ranges: range
      | ranges ',' range
      ;

range: expression TO expression {scase_case_range_double();}
     | expression {scase_case_range_single();}
     ;

event_name: _ERROR ;

maybe_ST_DELIM : | ST_DELIM ;

ST_DELIM : CL_DELIM | NL_DELIM;
inum:INUMBER {$$=atol(yytext);} ;

%%
extern char *yytext;

int main(int argc,char* argv[]) {
 if (argc==1) {
   fprintf(stderr,auth);
   fprintf(stderr,"Running in interactive mode (ctrl-c marks end).\n Welcome!\n");
 } else {
   yyin=fopen(argv[1],"r");
   if (yyin==NULL) {
      fprintf(stderr,auth);
      fprintf(stderr,"*** error: can't open `%s'\n",argv[1]);
      return 1;
   }
   linfo_name=argv[1];
 }

 up_and_go();
 return 0;
} 

void yyerror(char* s) {
  printf("line %ld:Error parsing at %s: %s\n",lineno,yytext,s);
}
	  