/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
message printing in style of gnucc.
taken as is from mine another translator - fcc
*/

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "glb.h"


//message reporting from fcc 0.1
char *skipsp(char *st) 
;

enum rep_flags {
    REP_HEADER = 1 << 0,	//print header "file:line:"
    REP_INDENT = 1 << 1,	//print \t
    REP_SINDENT = 1 << 2,	//print \t
    REP_HINDENT = 1 << 3,	//indent at header length
    REP_HEADER_FILE = 1 << 7,	// -.-
    REP_HEADER_LINE = 1 << 8	// -.-
};


long ctx_pos[50];
int ctxp = -1;

void mprint(int flg, char *str, int mwidth)
{
    unsigned int glen, mlen;
    char t, *tt;
    glen = mwidth - strlen(linfo_name) - 8;
    str = skipsp(str);
    while (str) {
	if (strlen(str) > glen) {
	    mlen = glen - 2;
	    t = str[glen - 2];
	    str[mlen] = '\0';
	    tt = rindex(str, ' ');
	    if (tt == NULL)
		break;
	    if ((glen - (tt - str)) < 30) {
		mlen = tt - str;
	    }
	    str[glen - 2] = t;
	    t = str[mlen];
	    str[mlen] = '\0';
	    if (flg & REP_INDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_SINDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_HINDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_HEADER)
		fprintf(stderr, "%s:%ld: ", linfo_name, lineno);
	    else {
		if (flg & REP_HEADER_FILE)
		    fprintf(stderr, "%s: ", linfo_name);
		if (flg & REP_HEADER_LINE)
		    fprintf(stderr, "%ld: ", lineno);
	    }
	    fprintf(stderr, "%s", skipsp(str));
	    if (mlen == glen - 2)
		fprintf(stderr, "_\n");
	    else
		fprintf(stderr, "\n");
	    str[mlen] = t;
	    str += mlen;
	} else {
	    if (flg & REP_INDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_SINDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_HINDENT)
		fprintf(stderr, "\t");
	    if (flg & REP_HEADER)
		fprintf(stderr, "%s:%ld: ", linfo_name, lineno);
	    else {
		if (flg & REP_HEADER_FILE)
		    fprintf(stderr, "%s: ", linfo_name);
		if (flg & REP_HEADER_LINE)
		    fprintf(stderr, "%ld: ", lineno);
	    }
	    fprintf(stderr, "%s\n", skipsp(str));
	    break;
	}
    }
}

void msgrep(int msgtype, const char *g, ...)
{
    char *buf, *p1, *s, *so, *my_s, pt;
    int my_d;
    char my_c;
    long my_l;
    va_list ap;
    s = strdup(g);
    so = s;
    if (!(buf = (char *) calloc(4048, sizeof(char)))) {
	fprintf(stderr, "out of memory");
	exit(0);
    }
    va_start(ap, g);
    if (msgtype & mWRN)
	sprintf(buf, "warning: ");
    if (msgtype & mNOT)
	sprintf(buf, "note: ");

    p1 = s;
    while (*s) {
	if (*s == '%') {
	    *s = 0;
	    sprintf(buf, "%s%s", buf, p1);
	    *s = '%';
	    p1 = s + 2;
	    s++;
	    switch (*s) {
	    case 'd':
		my_d = va_arg(ap, int);
		sprintf(buf, "%s%d", buf, my_d);
		break;
	    case 'c':
		my_c = va_arg(ap, char);
		sprintf(buf, "%s%c", buf, my_c);
		break;
	    case 'l':
		my_l = va_arg(ap, long);
		sprintf(buf, "%s%ld", buf, my_l);
		break;
	    case 's':
		my_s = va_arg(ap, char *);
		sprintf(buf, "%s%s", buf, my_s);
		break;
	    }

	}
	if (*s == '\n' || *s == '\t') {
	    pt = *s;
	    *s = 0;
	    sprintf(buf, "%s%s", buf, p1);
	    *s = pt;
	    p1 = s + 1;
	    ++s;
	    sprintf(buf, "%s ", buf);
	}
	s++;
    }
    sprintf(buf, "%s%s", buf, p1);
    mprint(REP_HEADER, buf, 80);
    free(buf);
    free(so);
    va_end(ap);
    if (msgtype == mHLT)
	exit(0);
    if (msgtype == mERR)
	exit(0);
}

char *msg_class(int t)
{
    switch (t) {
    case cSPEC:
	return "spec";
    case cCONST:
	return "const";
    case cSCALAR:
	return "scalar";
    case cARRAY:
	return "array";
    case cFUN:
	return "function";
    }
    return "class:other";
}

char *msg_type(int t)
{
    switch (t) {
    case stANY:
	return "spec";
    case tVOID:
	return "void";
    case tINT:
	return "int";
    case tDBL:
	return "double";
    case tSTR:
	return "string";
    case tLONG:
	return "long";
    case tREAL:
	return "real";
    case tWORD:
	return "word";
    case tDWORD:
	return "dword";
    case tBYTE:
	return "byte";
    }
    return "type:other";
}






char *skipsp(char *st) 
{
    
while (isspace(*st))
	st++;
    
return st;

}


