#define DIMS(x)   arp[x].dims
#define TP(x)     arp[x].tp
#define SF(x)     arp[x].flg
#define FDIMS(x)  arp[symtab[x].ttp.tp].dims
#define FTP(x)    arp[symtab[x].ttp.tp].tp
#define FF(x)     ((arr_d*) symtab[x].adata)->flg
#define SNTH(x,y) ((arr_d*) symtab[x].adata)->d.dim_v[y]	     // Y-th dimension of X-th array (static)
#define DNTH(x,y) ((arr_d*) symtab[x].adata)->d.dim_e[y]	     // Y-th dimension of X-th array (dynamic)

#ifndef ARR_T_
#define ARR_T_
struct arr_t_ {
    char flg;
    int tp;			// type of data
    unsigned short int dims;	// number of dimens.
};

typedef struct arr_t_ arr_t;
#endif

extern arr_t *arp;

struct etp_ {
    int tp;
    int cl;
};
typedef struct etp_ etp;

struct usert_ {
    long agr;
    int flg;
    long symp;
    int extc;
    int *ext;
};
typedef struct usert_ usert;


struct symt_ {
    char *name;
    char flg;
    int scope;
    etp ttp;
    void *adata;
};
typedef struct symt_ symt;

enum name_flags {
    nf_BYVAL = 1 << 0,
    nf_BYREF = 1 << 1,
    nf_OPTIONAL = 1 << 3,
    nf_EXTYPE = 1 << 4,
    nf_ARTYPE = 1 << 5,
    nf_PROTECTED = 1 << 6,
    nf_EXTERN = 1 << 7
};


enum type_flags {
    tp_WINIT = 1 << 0,
    tp_WKILL = 1 << 1
};


extern char *c_err, *c_arr, *c_scl, inside_type;


extern const etp s_SYMB, s_NAME_SC, s_NAME_AR, CT_INT, CT_DBL, SC_INT,
    SC_DBL, CT_STR;
extern int cscope, TP_STRUCTS, class_count, type_count, last_class,
    last_type, symf, namef;


void symtab_dec(long p);
void create_symtab();
void free_symtab();
int symtab_look(const char *name, int scope);
long symtab_add_sym(char *name, int tp, int cl, int scope);
long symtab_add_sym_full(char *name, int tp, int cl, int scope, void *d);
etp symtab_get_sym(char *name);
etp sym_get_sym_arr();
void symtab_add_sym_chk(char *name, int tp, int scope);
void symtab_show(char *ff);
void sym_enter_type(char *n);
void sym_leave_type();
long sym_get_type(char *n);
void tumble();
etp metp(int t, int c);
int symtab_type(long i);
int symtab_class(long i);
int symtab_name(long i);
int symtab_adata(long i);
void delete_scope(int s);
void analyze_for1();
void analyze_for2();
etp symtab_add_sym_chk_ret(char *name, int tp, int scope);
void usrtab_sf(int i, int f);
int symtab_scope(long i);
void write_subtypes_init(FILE * f, int tp);
void print_ini_val(FILE * wt, int p);
void symtab_set_adata(long i, void *e);
void symtab_set_sym_full(long s, char *name, etp t, int scope, void *d);
void analyze_me();
void symtab_set_flg(long i, int e);
int symtab_flg(long i);
void symtab_drop_flg(long i, int e);
int symtab_test_flg(long i, int f);
void sym_add_ext(char *n);
void symtab_add_sym_arr(char *name, int tp, int cl, int scope, int dims,
			void *adata);
void sym_set_type(char *nm, int tp);
