/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
array structures and some code
*/

#include <stdlib.h>
#include <stdio.h>

struct arr_t_ {
    char flg;
    int tp;
    unsigned short int dims;
};

typedef struct arr_t_ arr_t;

struct arr_d_ {
    int flags;
    union d {
	char **dim_e;
	long **dim_v;
    };
};

typedef struct arr_d_ arr_d;
enum arr_flg {
    af_DYNAMIC = 1 << 0,
    af_WRAP = 1 << 1,
    af_CHECK = 1 << 2,
    af_RESIZE = 1 << 3
};

arr_t *arp;
long arpc = -1;
long arpmax = 100;

void init_ar()
{
    arp = (arr_t *) malloc(arpmax * sizeof(arr_t));
}

void free_ar()
{
    free(arp);
}

int alloc_arr_type(int dt, int dm, char flg, int emc)
{
    int vc = 0, i;
    printf("to alloc:dt=%d; dm=%d;\n", dt, dm);
    if (arpc > -1)
	for (i = 0; i <= arpc; i++)
	    if (arp[i].tp == dt && arp[i].dims == dm) {
		vc = i;
		break;
	    }
    if (vc == 0 || emc) {
	arpc++;
	vc = arpc;
    }
    arp[vc].flg = flg;
    arp[vc].tp = dt;
    arp[vc].dims = dm;
    return vc;
}
