/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
compilation of structure statements, like IF, FOR and etc.
*/

#define is_iter_type(x) (x==tINT || x==tDBL)
#define is_bool_type(x) (x==tINT || x==tDBL)

int wlsc = -1;

int frsc = -1;
char *frs[256];
char frt[256];

void my_end()
{
    fprintf(out, "exit(0);\n");
}

void a_if_then()
{
    char *l;
    etp tl;
    l = popb(stk0, &tl);
    switch (tl.tp) {
    case tINT:
    case tDBL:
	fprintf(out, "if (%s) {\n", l);
	break;
    case tSTR:
	fprintf(out, "if (strlen(%s)) {\n", l);
	break;
    case tVOID:
    default:
	fprintf(stderr, "invalid expr. type\n");
	break;
    }
}


void a_if_else()
{
    fprintf(out, " } else { \n");
}

void a_if_end()
{
    fprintf(out, " }\n");
}

void analyze_for1()
{
    char *l, *stp_e, *to_e, *init_e;
    char emul = 0;		// used to compile st-s like 'FOR i=0 TO j STEP k'
    // where 'k' isn't a constant (-expr.)
    etp t;
    int stp_t, to_t, sg;
    l = popb(stk0, &t);
    frsc++;
    if (frsc == 256) {
	fprintf(stderr, "Too many FORs\n");
	exit(0);
    }
    if (t.cl == cSPEC) {
	stp_e = popb(stk0, &t);
	if (t.cl != cCONST)
	    emul = 2;
	else
	    emul = 1;
	stp_t = t.tp;
	if (!is_iter_type(stp_t))
	    fprintf(stderr,
		    " (vcmpl.c/35) Shit! need an iteratable type\n");
	to_e = popb(stk0, &t);
	to_t = t.tp;
    } else {
	to_e = l;
	to_t = t.tp;
    }
    init_e = popb(stk0, &t);
    to_t = t.tp;
    l = popb(stk0, &t);
    frt[frsc] = emul;

    if (emul) {
	if (emul == 2) {
	    fprintf(out, "%s=%s;\n while (((%s-%s)*", l, init_e, to_e, l);
	    switch (stp_t) {
	    case tINT:
		fprintf(out, "abs(%s", stp_e);
		break;
	    case tDBL:
		fprintf(out, "fabs(%s", stp_e);
	    }
	    fprintf(out, ")/%s)>=0) {\n", stp_e);
	    frs[frsc] = strdup(stp_e);
	    frs[++frsc] = strdup(l);
	    frt[frsc] = 2;
	    return;
	}
	sg = (int) atof(stp_e);
	fprintf(out, "for(%s=%s;%s", l, init_e, l);
	if (sg > 0)
	    fprintf(out, "<");
	else
	    fprintf(out, ">");
	fprintf(out, "=%s;%s", to_e, l);
	fprintf(out, "+=%s) {\n", stp_e);
	frs[frsc] = strdup(l);
	return;
    }
    frs[frsc] = strdup(l);
    fprintf(out, "for(%s=%s;%s<=%s;%s++) {\n", l, init_e, l, to_e, l);
}

void analyze_for2()
{
    int my_bp = 0;
    char *l, *r;
    if (frsc == -1) {
	fprintf(stderr, " NEXT without FOR\n");
	return;
    }
    begin_scan(stk0);
    if (stk0->buf2p >= 0)
	while (my_bp <= stk0->buf2p) {
	    l = scan(stk0);
	    r = frs[frsc];
	    if (strcasecmp(l, r)) {
		fprintf(stderr,
			" NEXT %s without FOR %s (expected NEXT %s)\n", l,
			l, r);
		return;
	    }
	    if (frt[frsc] == 2) {
		fprintf(out, "%s+=%s;\n", frs[frsc], frs[frsc - 1]);
		free(frs[frsc - 1]);
		frsc--;
	    }
	    free(frs[frsc]);
	    frsc--;
	    if (frsc == -2) {
		fprintf(stderr, " NEXT without FOR\n");
		frsc = -1;
		return;
	    }
	    my_bp++;
	    fprintf(out, " }\n");
    } else {
	if (frt[frsc] == 2) {
	    fprintf(out, "%s+=%s;\n", frs[frsc], frs[frsc - 1]);
	    free(frs[frsc - 1]);
	    frsc -= 2;
	    return;
	}
	frsc--;
	fprintf(out, "} \n");
    }
}

void analyze_while1()
{
    char *e;
    etp t;
    e = popb(stk0, &t);
    if (!is_bool_type(t.tp))
	fprintf(stderr, "expected bool type\n");
    fprintf(out, "while (%s) {\n", e);
    wlsc++;
}

void analyze_wend()
{
    fprintf(out, "}\n");
}

void exit_while()
{
    if (wlsc == -1)
	msgrep(mERR, "EXIT LOOP outside any loop contruction");
    fprintf(out, "break;\n");
}

void exit_for()
{
    if (frsc == -1)
	msgrep(mERR, "EXIT FOR outside FOR");
    fprintf(out, "break;\n");
}

void cont()
{
    if (frsc == -1 && wlsc == -1)
	msgrep(mERR, "CONTINUE outside FOR/loop contruction");
    fprintf(out, "continue;\n");
}
